#!/usr/bin/python
# -*- coding: latin-1 -*-
"""
proyecto: juk-100
descripcion: rc 1/18 autonomo, una camara, cuatro ruedas ,+rpi
soft: raspbian + python + C + bash
autor   : jgf
fechas  : inicio 14-2-16 v100, final ind
licencia: gpl
version : v1.100
PROGRAMA:
 JLcom.py: programa de comunicaciones BT Server ARCWagen
DESCRIPCION:
descripcion funciones:
 - server_bt_sh_activ():
 - server_bt_sh_stat():
 - server_bt_sh_write():
 - server_bt_sh_list_clients():
 - server_bt_sh_end():
 - server_bt_sh_read_clients():
 - server_bt_sh_del_client():
 - server_bt_sh_help():
 - client_bt_sh_enll():
 - client_bt_sh_ini():
 - s_bt_sh_pk_ref():
 - s_bt_sh_pk_w():
 - s_bt_sh_pk_e():
 - s_bt_sh_pk_list():
 - s_bt_sh_pk_list_all():
"""
import bluetooth as bt
import pickle as pk
import uuid 
import os, time, sys, re
import subprocess as sp
s_stat='s_off'
skt_srv_bt,skt_bt=[],[]
l_jcom=[]
l_files_pk=['../log/srv_bt.log',
            '../run/jcom.pk',
            '../run/jcom_srv.pk',
            '../run/jcom_srv_w.pk',
            '../run/jcom_srv_r.pk',
            '../run/jcom_srv_e.pk',
            '../run/jcom_srv_w.dat',
            '../run/jcom_srv_r.dat',
            '../run/jcom_srv_e.dat',
            '../log/jcom_srv_w.log',
            '../log/jcom_srv_r.log',
            '../log/jcom_srv_e.log']
l_cmm=['fn','it','cl','ls','td','rm','cat']
l_endian=['connect','connected','close','closed','active','listen','refus','refused','writed']
def server_bt_sh_activ():
    global skt_srv_bt
    global s_stat
    global l_files_pk
    print '- BT Server ARCW activ: '
    #print s_stat
    if os.path.exists(l_files_pk[2]) and s_stat=='s_off':
        with open(l_files_pk[2],'rb') as f:
            skt_srv_bt=pk.load(f)
    elif len(skt_srv_bt)<1 :
        server_sock=bt.BluetoothSocket( bt.RFCOMM )
        server_sock.setblocking(False)
        if os.path.exists(l_files_pk[1]):
            with open(l_files_pk[1], 'rb') as fp:   #Unpickling
                l_tmp=pk.load(fp)
                #print l_tmp
            adr,port,uid,l_stat=l_tmp
            server_sock.bind((adr,port))
            skt_srv_bt.append(server_sock)
            print 'Open socket BT-Server-ARCW.'
            s_stat='s_on'
        else:
            print 'Not find parameters file BT-Server-ARCW.'
            s_stat='s_err_jcom'
    elif s_stat=='s_on':
        server_sock=skt_srv_bt[0].dup()
        server_sock.settimeout(30)
        server_sock.listen(1)
        bt.advertise_service( server_sock, "BT-Server-ARCW",
                              service_id = uid,
                              service_classes = [ uid, bt.SERIAL_PORT_CLASS ],
                              profiles = [ bt.SERIAL_PORT_PROFILE ])
        print 'Waiting connection ARCW.'
        try:
            client_sock,client_info = server_sock.accept()
        except bt.BluetoothError as err:
            t = time.localtime()
            with  open(l_files_pk[0],'a') as f_log:
                f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
            j_stat='err-3'
        if j_stat!='err-3':
            if os.path.exists(l_files_pk[5]):
                with open(l_files_pk[5],'r') as f:
                    l_clients=pk.load(f)
                for i_c,(client_adr,c_stat) in enumerate(l_clients):
                    if client_info[0]==client_adr:
                        if c_stat==l_endian[6] or c_stat==l_endian[7]:
                            client_sock.close()
                            l_clients[i_c]=(client,l_endian[7])
                        elif c_stat==l_endian[0]:
                            l_clients[i_c]=(client,l_endian[1])
                            skt_srv_bt.append((client_sock,client_info))
                            print 'Accepted connection from: ', client_info[0]
                            break
                        elif c_stat==l_endian[5]:
                            client_sock.close()
                            break
                    else:
                        with open(l_files_pk[11],'a') as f_log:
                            f_log.writelines('({t0}:{t1}:{t2}):Ref-cli:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=client_info[0]))
                        #l_clients.append(client_info[0],l_endian[5])
                        client_sock.close()
                        print 'Unknown connection from: ', client_info[0]
                    with open(l_files_pk[5],'w') as fd:
                        pk.dump(l_clients,fd)
            with open(l_files_pk[2],"w") as fd:
                #print 'len:',len(skt_srv_bt)
                pk.dump(skt_srv_bt,fd)
        else:
            with open(l_files_pk[0],'a') as f_log:
                f_log.writelines('({t0}:{t1}:{t2}):Server:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=j_stat))
                                             
def server_bt_sh_stat():
    global l_files_pk
    print '- Server ARCW stat clients:'
    with open(l_files_pk[5],'r') as f:
        l_clients=pk.load(f)
    for client_adr,c_stat in l_clients:
        print '<{0}>: {1}'.format(client_adr,c_stat)
                                             
def server_bt_sh_write():
    global skt_srv_bt
    global s_stat
    global l_files_pk
    global l_cmm
    print '- Server ARCW write clients:'
    if os.path.exist(l_files_pk[3]):
        with open(l_files_pk[3],"r") as fp:
            l_jcom=pk.load(fp)
        for adr,dat_write in l_jcom:
            for kt in range(1,len(skt_srv_bt)):
                sck_client, client_addr = skt_srv_bt[kt]
                #if sck_client.getsockname()==adr:
                if client_addr==adr:
                    sck_client.settimeout(3)
                    try:
                        if len(dat_write)!=1 and dat_write!=l_cmm[6]:
                            sck_client.send(dat_write)
                    except bt.BluetoothError as err:
                        t = time.localtime()
                        with  open(l_files_pk[9],'a') as f_log:
                            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
                        #s_stat='err-3'
                    else:
                        print 'Write client<{0}>'.format(adr)
                        t = time.localtime()
                        with  open(l_files_pk[9],'a') as f_log:
                            f_log.writelines('({t0}:{t1}:{t2}):tx:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=adr))
                        break
    else:
        print 'No write.pk'
        s_stat='err_w_pk'

def server_bt_sh_list_clients():
    global skt_srv_bt
    global s_stat
    global l_files_pk
    try:
        print '- Server ARCW list clients:'
        for kt in range(1,len(skt_srv_bt)):
            sck_client, client_info = skt_srv_bt[kt]
            print client_info
    except bt.BluetoothError as err:
        t = time.localtime()
        with  open(l_files_pk[0],'a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' err:',err)
            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
        s_stat='err-3'
    finally:
        t = time.localtime()
        with  open(l_files_pk[0],'a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' stat:',-l)
            f_log.writelines('({t0}:{t1}:{t2}):stat-l:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=s_stat))

def server_bt_sh_end():
    global skt_srv_bt
    global s_stat
    global l_files_pk
    try:
        print '- Server ARCW off-clients:'
        if os.path.exist("../run/jcom_e.pk"):
            with open("../run/jcom_e.pk","r") as fp:
                l_jcom=pk.load(fp)
            for adr,dat_write in l_jcom:
                for kt in range(1,len(skt_srv_bt)):
                    sck_client, client_info = skt_srv_bt[kt]
                    if sck_client.getsockname()==adr and dat_write == 'closed':
                        sck_client.shutdown()
                        sck_client.close()
        else:
            s_stat='err_e_pk'
    except bt.BluetoothError as err:
        t = time.localtime()
        with  open('../log/srv_bt.log','a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' err:',err)
            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
        s_stat='err-3'
    finally:
        t = time.localtime()
        with  open('../log/srv_bt.log','a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' stat:',s_stat)
            f_log.writelines('({t0}:{t1}:{t2}):stat-e:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=s_stat))

def server_bt_sh_read_clients():
    global skt_srv_bt
    global s_stat
    global l_files_pk
    l_dat_clients=list()
    dat_client=None
    try:
        print '- Server ARCW read clients: '
        if os.path.exist("../run/jcom_r.pk"):
            with open("../run/jcom_r.pk","r") as fp:
                l_dat_clients=pk.load(fp)
        for kt in range(1,len(skt_srv_bt)):
            sck_client, client_info = skt_srv_bt[kt]
            sck_client.settimeout(5)
            dat_client=sck_client.recv(24)
            if len(dat_client)>0:
                l_dat_clients.append((sck_client.getsockname(),dat_client))
        #print(l_dat_clients)
    except bt.BluetoothError as err:
        t = time.localtime()
        with  open('../log/srv_bt.log','a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' err:',err)
            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
        s_stat='err-3'
    finally:
        with open("../run/jcom_r.pk","w") as fp:
            pk.dump(l_dat_clients,fp)
        t = time.localtime()
        with  open('../log/srv_bt.log','a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' stat:',-r)
            f_log.writelines('({t0}:{t1}:{t2}):stat-r:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=s_stat))
                        
def server_bt_sh_del_client(adrr):
    global skt_srv_bt
    global s_stat
    l_clients=list()                            
    try:
        print '- Server ARCW delete clients: '
        if os.path.exist(l_files_pk[5]):
            with open(l_files_pk[5],'r') as fp:
                l_clients=pk.load(fp)
        for kt in range(1,len(skt_srv_bt)):
            sck_client, client_info = skt_srv_bt[kt]
            if sck_client.getsockname()==adrr:
                l_clients.append((adrr,'closed'))
            else:
                print 'Not client address find.'
        with open(l_files_pk[5],'w') as fp:
            pk.dump(l_clients,fp)
    except bt.BluetoothError as err:
        t = time.localtime()
        with  open(l_files_pk[0],'a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' err:',err)
            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
        s_stat='err-3'
    finally:
        t = time.localtime()
        with  open(l_files_pk[0],'a') as f_log:
            #f_log.writeline(t.tm_min,':',t.tm_sec,' stat:',-d,' client:',l_clients)
            f_log.writelines('({t0}:{t1}:{t2}):stat-d:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=l_clients))
                        
def server_bt_sh_help():
    l_h= ['Help info shell Server ARCWagen        ',
          'name: file Scom.py                     ',
          'run:  python Scom.py                   ',
          'options:                               ',
          '[a][s][w][l][e][r][d addr][k addr][u][q][h] ',
          '   a Active server.                    ',
          '   s Stat server.                      ',
          '   w Send data to clients              ',
          '   l List active clients.              ',
          '   e Apli closed clients.              ',
          '   r Read demmans of clients.          ',
          '   d Closer device addr.               ',
          '   k Set ref. file server.             ',
          '   u Console unicurses.                ',
          '   q Close shell.                      ',
          '   h Print help.                       ',
          ]
    for k in l_h:
        print k

def client_bt_sh_ini():
    global j_stat
    global l_jcom
    global l_files_pk
    #s_stat='s_on'
    print 'Client BT load.'
    #print s_stat
    if os.name()=='posix':
        if os.path.exists(l_files_pk[1]):
            with open(l_files_pk[1],'rb') as f:
                #adr,port,uid,l_stat=l_jcom
                l_jcom=pk.load(f)
            if len(st_out=sp.chcek_output("hcitool dev; exit 0",stderr=None,shell=True).split())>3:
                l_jcom.append(st_out[3])
                #continue
            else:
                j_stat='err-3'
                print 'Not local device BT finded.'    
    else:
        j_stat='err-3'
    return j_stat

def client_bt_sh_enll():
    global j_stat
    global skt_bt
    global l_jcom
    global l_files_pk
    global l_cmm
    adr,port,uid,l_cmm_t=l_jcom[0]
    #if len(skt_bt)<1 and skt_bt.getsockname() is None:
    if len(skt_bt)<1:             
        try:
            serveis_bt = bt.find_service(name='BT-Server-ARCW', uuid=uid, address=adr )
        except bt.BluetoothError as err:
            t = time.localtime()
            with  open(l_files_pk[0],'a') as f_log:
                f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
            #j_stat='err-3'
        if len(serveis_bt) == 0:
            print 'Not find the Server-ARCW service.'
        else:
            for s_bt in serveis_bt:
                port_s_bt = s_bt["port"]
                name_s_bt = s_bt["name"]
                host_s_bt = s_bt["host"]
                if name_s_bt=='BT-Server-ARCW' and port_s_bt == port and host_s_bt == adr: 
                    skt=bt.BluetoothSocket(bt.RFCOMM)
                    try:
                        skt.connect((adr,port))
                    except bt.BluetoothError as err:
                        t = time.localtime()
                        with  open(l_files_pk[0],'a') as f_log:
                            f_log.writelines('({t0}:{t1}:{t2}):err:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=err))
                        j_stat='err-3'
                    else:
                        break
    else:
        #skt=skt_bt
        skt=skt_bt.dup()
    #ad_rem=skt.getpeername()
    skt.settimeout(15)
    try:
        skt.send(j_stat)
    except bt.BluetoothError as err:
        pass
    try:
        d_stat=skt.recv(24)
    except bt.BluetoothError as err:
        pass
    #print repr(d_stat)
    if len(d_stat)==1:
        if d_stat==l_cmm[0]:
            skt_bt.close()
    elif len(d_stat)<3:
        if d_stat[1]==l_cmm[1]:
            j_stat=d_stat[2]
    skt_bt=skt.dup()
    skt.close()
    t = time.localtime()
    with  open(l_files_pk[0],'a') as f_log:
        f_log.writelines('<{t0}:{t1}:{t2}>:stat:{s}:'.format(t0=t.tm_hour,t1=t.tm_min,t2=t.tm_sec,s=j_stat))
    return j_stat

def s_bt_sh_pk_ref(adrr):    
    global l_cmm
    global l_files_pk
    port = 353
    uid = uuid.uuid1()
    x_reg='([a-fA-F0-9]{2}[:|]?){6}'
    l_jcom=adrr,port,uid,l_cmm
    if re.compile(x_reg).search(adrr):
        with open(l_files_pk[1], "wb") as fp:   #Unpickling
            pk.dump(l_jcom,fp)
            print 'Set file ref. BT-Server-ARCW on: ', l_files_pk[1]
    else:
        print 'BT Error on mac address: ',adrr

def s_bt_sh_pk_w():    
    global l_cmm
    global l_files_pk
    k_kc,k_cmm,k_lin=0,0,0
    l_comm,l_cmm_t,l_lin=[],[],[]
    f_w=True
    x_reg='([a-fA-F0-9]{2}[:|]?){6}'
    if os.path.exists(l_files_pk[6]):
        with open(l_files_pk[6],'rb') as f:
            for lin in f:
                l_lin.append(lin.split(';'))
            #print l_lin
        for adrr,l_cmm_t in l_lin:
            k_lin+=1
            if re.compile(x_reg).search(adrr):
                k_kc=k_cmm=0
                l_cmm_tmp=[]
                l_cmm_s=l_cmm_t.split(',')
                #print l_cmm_s
                for kc in l_cmm_s:
                    kc = kc.replace("\n","")
                    k_kc+=1
                    l_cmm_tmp.append(kc)
                    #print l_cmm_s
                    for kcmm in l_cmm:
                        #print kc,'===',kcmm
                        if kc==kcmm:
                            k_cmm+=1
                            if kc==l_cmm[1]:
                                k_cmm+=1
                if k_kc==k_cmm:
                    #print l_cmm_tmp
                    l_comm.append((adrr,l_cmm_tmp))
                else:
                    print 'Commands not corrects: file<{0}> line<{1}>'.format(l_files_pk[6],k_lin)
                    f_w=False
            else:
                print 'Address not correct: file<{0}> line<{1}>'.format(l_files_pk[6],k_lin)
        if f_w:
            for addr,l_cmm_s in l_comm:
                with  open(l_files_pk[9],'a') as f_log:
                    f_log.writelines('<{0}>:{1}'.format(addr,l_cmm_s))
            with open(l_files_pk[3], "w") as fp:
                pk.dump(l_comm,fp)
            print 'Maked pickle file.dat of send data clients'
    else:
        print 'Not exists file.dat to send data clients'

def s_bt_sh_pk_e():    
    global l_files_pk
    global l_endian
    k_lin=0
    l_estats_dat,l_estats_pk,l_s_t=[],[],[]
    f_w,f_t=True,False
    x_reg='([a-fA-F0-9]{2}[:|]?){6}'
    print '- Server ARCW pickle stats: '
    if os.path.exists(l_files_pk[5]):
        with open(l_files_pk[5],'rb') as fk:
            l_estats_pk=pk.load(fk)
    if os.path.exists(l_files_pk[8]):
        with open(l_files_pk[8],'rb') as fd:
            for lin in fd:
                l_estats_dat.append(lin.split(';'))
        for t_adr,t_estat in l_estats_dat:
            t_estat=t_estat.rstrip()
            k_lin+=1
            if re.compile(x_reg).search(t_adr):
                if t_estat in l_endian[::]:
                    if len(l_estats_pk)>1:
                        for ix,(adr,estat) in enumerate(l_estats_pk):
                            if adr==t_adr and estat != l_endian[7]:
                                l_estats_pk[ix]=adr,t_estat
                                f_t=True
                                break
                            else:
                                f_t=False
                        if not f_t:
                            if t_estat != l_endian[7]:
                                l_estats_pk.append((t_adr,t_estat))
                        f_t=False
                    else:
                        if t_estat != l_endian[7]:
                            if len(l_s_t)<1:
                                l_s_t.append((t_adr,t_estat))
                            else:
                                f_t=False
                                for adr_t,estat_t in l_s_t:
                                    if t_adr==adr_t:
                                        break
                                    else:
                                        f_t=True
                                if f_t: 
                                    l_s_t.append((t_adr,t_estat))
                        f_t=True
                else:
                    print 'Stat client not correct: file<{0}> line<{1}>'.format(l_files_pk[8],k_lin)
                    f_w=False
            else:
                f_w=False
                print 'Address not correct: file<{0}> line<{1}>'.format(l_files_pk[8],k_lin)
            if not f_w:
                break
        if f_w:
            if f_t:
                l_estats_pk.extend(l_s_t)
            for adr,estat in l_estats_pk:
                with  open(l_files_pk[11],'a') as f_log:
                    f_log.writelines('<{0}>:{1}'.format(adr,estat))
            with open(l_files_pk[5], "w") as fp:   
                pk.dump(l_estats_pk,fp)
            print 'Maked pickle file.dat of stat data clients.'
    else:
        print 'Not exists file.dat to stat clients.'

def s_bt_sh_pk_list():    
    global l_files_pk
    global l_endian
    l_lin=list()
    print '- Server ARCW list activ clients: '
    if os.path.exists(l_files_pk[8]):
        with open(l_files_pk[8],'r') as f:
            for lin in f:
                l_lin.append(lin.split(';'))
        for addr,s_endian in l_lin:
            s_endian = s_endian.replace("\n","")
            if s_endian == l_endian[0]:
                print 'Client address <{0}>: {1}.'.format(addr,s_endian)
    else:
        print 'Not exists file<{0}> to list clients'.format(l_files_pk[8])
        
def s_bt_sh_pk_list_all():    
    global l_files_pk
    global l_endian
    l_lin=list()
    print '- Server ARCW list all clients: '
    if os.path.exists(l_files_pk[8]):
        with open(l_files_pk[8],'r') as f:
            for lin in f:
                l_lin.append(lin.split(';'))
        for addr,s_endian in l_lin:
            s_endian = s_endian.replace("\n","")
            print 'Client address <{0}>: {1}.'.format(addr,s_endian)
    else:
        print 'Not exists file<{0}> to list clients'.format(l_files_pk[8])
