#!/usr/bin/python
# -*- coding: latin-1 -*-
"""
proyecto: juk-100
descripcion: rc 1/18 autonomo, una camara, cuatro ruedas ,+rpi
soft: raspbian + python + C + bash
autor   : jgf
fechas  : inicio 14-2-16 v100, final ind
licencia: gpl
version : v1.100
PROGRAMA
 Lvas.py:Llibreria Visualitzacio Artificial de Segments
DESCRIPCION
 Analisis de segment en arxius de imatge
 def. de funcions:
 - araknit_ini:fracciona la imatge, en cups.
 - araknit_ref: de cada punt trobat, amb el color ref., intenta continuar una linea.
 - araknit_list : idem ref, us de llistats de punts.
 - araknit_list_diff: idem list, detecta variacions de color fent un promig de n punts horitzontals.
 - formiga: espera un increment de punts de color vermell.
 - comput_mov: calcula el vector promig de segments.
 - comput_dir: a partir del vector promig de moviment determina l'angle i el sentit de la direccio.
 - comput_dir_kmp: torna l'angle i sentit per las coordenas del kompas.
 - comput_pos:
 - comput_acc:
 - comput_acc_fx:
 - comput_tram:
 - comput_tram_map:
 - navg_ini:
 - navg_fi:
 - navg_timon:
 - navg_acc:
 - plot_pin:
 - plot_lin:
 - plot_lin_vm:
 - plot_gri:
"""
#LIBRERIAS
from PIL import Image, ImageDraw
#from picamera import PiCamera
#import numpy as np
#import itertools as itt
#import os.path as pth
import RPi.GPIO as gp
#import LSM303C as kmp
#import time
#GLOBALES
tim='../ima/tmp/'
pv_w,kubo=0,0
lc_im,lc_pr=[],[]
def araknit_ini(im_size):
    #global im_size
    l_eim,l_epr=[],[]
    ah,at=im_size
    k_n,n_cub_s,qav=.5,0,5
    res,rt,cub=358,qav**2,at//qav
    for kav in range(qav,qav*2+1,1):
        ch,ct=ah//kav,at//kav
        rt=ah%ct+at%ch
        if rt<=res :
            cub= ah//kav
            res=rt
        #print 'kav:{0}, rt:{1}-{3} cub:{2}'.format(kav,rt,cub,res)
    n_cub_h,n_cub_t=ah//cub , at//cub
    if (n_cub_h*n_cub_t)%2==0:
        k_h,k_t=n_cub_h-n_cub_s,n_cub_t-n_cub_s
    else:
        k_h,k_t=n_cub_h,n_cub_t-n_cub_s
    # divisio imatge en sectors, tamany cub
    l_cups=[[(h,t) for h in range(0,cub*k_h,cub)] for t in range(0,cub*k_t,cub)]
    l_cups_im=l_cups[int(k_t*k_n):len(l_cups):None]
    l_cups_pr=l_cups[0:int(k_t*k_n):None]
    lc_im_f=[[x for i,x in enumerate(l_x) if i%2==0] if l_i%2==0 else [x for i,x in enumerate(l_x) if i%2!=0] for l_i,l_x in  enumerate(l_cups_im)]
    lc_pr_f=[[x for i,x in enumerate(l_x) if i%2==0] if l_i%2==0 else [x for i,x in enumerate(l_x) if i%2!=0] for l_i,l_x in  enumerate(l_cups_pr)]
    for l_im in lc_im_f:
        l_eim.extend(l_im)
    for l_pr in lc_pr_f:
        l_epr.extend(l_pr)
    #print 'cub={0},{1}'.format(cub,res)
    #print 'nh,nt={0},{1}'.format(n_cub_h,n_cub_t)
    #print 'kh,kt={0},{1}'.format(k_h,k_t)
    #print 'l_cups<{0}>:  {1}'.format(len(l_cups),l_cups)
    #print 'list_pr<{0}>: {1}'.format(len(l_cups_pr),l_cups_pr)
    #print 'list_im<{0}>: {1}'.format(len(l_cups_im),l_cups_im)
    #print 'l_pr_f<{0}>:  {1}'.format(len(lc_pr_f),lc_pr_f)
    #print 'l_im_f<{0}>:  {1}'.format(len(lc_im_f),lc_im_f)
    #print 'l_epr<{0}>:   {1}'.format(len(l_epr),l_epr)
    #print 'l_eim<{0}>:   {1}'.format(len(l_eim),l_eim)
    return cub,l_eim,l_epr 

def araknit_list_diff(im,l_cups,cup):
    k_pix=3
    pix_rgb=255
    pix_diff=int(pix_rgb*.17)
    t_pix = im.load()
    l_hmin=int(cup*.05)
    l_hmax=int(cup*.95)
    l_vmax=int(cup*1.25)
    l_vmin=int(cup*.35)
    lin,lin_t=[],[]
    pin,pin_t=[],[]
    # la aranya fa taranyinas 
    for kpx in l_cups:
        for kt in range(cup):
            for kh in range(0,cup-2*k_pix,k_pix):
                if abs(sum([sum(t_pix[(kpx[0]+kh+k_x,kpx[1]+kt)]) for k_x in range(k_pix)]) - sum([sum(t_pix[(kpx[0]+kh+k_ix+k_pix, kpx[1]+kt)]) for k_ix in range(k_pix)])) // (3*k_pix) >= pix_diff:
                    pin.append((kpx[0]+k_pix+kh,kpx[1]+kt))
        #print 'cup<{0}> pin<{1}> lin<{2}>'.format(kpx,len(pin),len(lin))
        if len(pin)>0:
            for pin_n in pin:
                if len(lin_t)>0:
                    for i_t,(pin_n0,pin_n1) in enumerate(lin_t):
                         if abs(pin_n[0] - pin_n1[0]) <= k_pix and abs(pin_n[1] - pin_n1[1]) <= k_pix:
                            lin_t[i_t]=(pin_n0,pin_n)
                            break
                         elif i_t == len(lin_t)-1:
                            lin_t.append((pin_n,pin_n))
                else:
                    lin_t.append((pin_n,pin_n))
            pin_t.extend(pin)
            lin.extend(lin_t)
            lin_t=[]
            pin=[]
    lin_t=[(pin_n0,pin_n1) for i_n,(pin_n0,pin_n1) in enumerate(lin) if l_vmax > abs(pin_n0[1] - pin_n1[1]) > l_vmin]
    #del lin[:]
    #print 'lin<{0}>:{1} \n lin_t<{2}>:{3}'.format(len(lin),lin,len(lin_t),lin_t)
    #print 'pin<{0}> lin<{1}>'.format(len(pin),len(lin))
    print 'pin_t<{0}> lin_t<{1}>'.format(len(pin_t),len(lin_t))
    return lin_t,pin_t
    
def araknit_list(im,l_cups,cup):
    #global lc_im, lc_pr
    #global kubo
    bl=255
    abl=int(bl*.37)
    #ah,at=im.size
    pix = im.load()
    l_hmin=int(cup*.03)
    l_hmax=int(cup*.95)
    l_vmax=int(cup*1.25)
    l_vmin=int(cup*.25)
    l_pv_n0=(0,0)
    l_pv_n1=(0,0)
    l_pv_ni=(0,0)
    l_ph_ni=(0,0)
    l_ph_n0=(0,0)
    l_ph_n1=l_cups[0]
    #print l_ph_n1
    lin=[]
    lin_t=[]
    l_ind=[]
    pin=[]
    pin_t=[]
    # la aranya fa taranyinas
    for kpx in l_cups:
        l_ch=0
        for kt in range(cup):
            for kh in range(cup):
                l_ph_ni=(kpx[0]+kh,kpx[1]+kt)
                if ((bl-abl)*3) <= sum(pix[l_ph_ni]) <= (bl*3):
                    if abs(l_ph_ni[0] - l_ph_n1[0]) < 2:
                        l_ch+=1
                        if l_ch == 1:
                            l_ph_n0=l_ph_n1
                    elif l_hmin <= l_ch <= l_hmax:
                        pin.append((int((l_ph_n1[0] + l_ph_n0[0])/2),l_ph_n1[1]))
                        l_ch = 0
                    l_ph_n1=l_ph_ni
        #print 'cup<{0}> pin<{1}> lin<{2}>'.format(kpx,len(pin),len(lin))
        #print 'pin<{0}>:{1}'.format(len(pin),pin)
        if len(pin)>0:
            for pin_n in pin:
                if len(lin_t)>0:
                    for i_t,(pin_n0,pin_n1) in enumerate(lin_t):
                         if abs(pin_n[0] - pin_n1[0]) < l_hmin and abs(pin_n[1] - pin_n1[1]) < l_hmin:
                            lin_t[i_t]=(pin_n0,pin_n)
                            break
                         elif i_t == len(lin_t)-1:
                            lin_t.append((pin_n,pin_n))
                else:
                    lin_t.append((pin_n,pin_n))
            pin_t.extend(pin)
            lin.extend(lin_t)
            lin_t=[]
            pin=[]
    l_ind=[i_n for i_n,(pin_n0,pin_n1) in enumerate(lin) if abs(pin_n0[1] - pin_n1[1])< l_vmin]
    lin_t=[x for i,x in enumerate(lin) if i not in l_ind]
    del lin[:]
    #print 'lin<{0}>:{1} \n lin_t<{2}>:{3}'.format(len(lin),lin,len(lin_t),lin_t)
    #print 'pin<{0}> lin<{1}>'.format(len(pin),len(lin))
    print 'pin_t<{0}> lin_t<{1}>'.format(len(pin_t),len(lin_t))
    #print 'lin<{0}> lin_t<{1}>'.format(len(lin),len(lin_t))
    return lin_t,pin_t

def araknit_ref(im):
    bl=255
    abl=int(bl*.27)
    ah,at=im.size
    pix = im.load()
    res,rest,resth=0,0,0
    qav=5
    kubo=at//qav
    for kk in range(qav,int(qav*2),1):
        res=at%kk
        if rest<res :
            kubo= at//kk
            rest=res
            resth=ah%kubo
    cbt=(at//kubo)
    #kbt=cbt
    cbh=(ah//kubo)
    kbh=cbh
    #print ah,at,kubo
    kbt=cbt-1
    kpos=list()
    l_fv=True
    # divisio imatge en sectos, tamany kubo
    while kbt:
        l_f=True
        kbh=cbh-1
        if l_fv :
            l_fv=False
            while kbh:
                if l_f:
                    kpos.append((kubo*kbh, kubo*kbt))
                    l_f=False
                else:
                    l_f=True
                kbh-=1
        else: 
            l_fv=True
            while kbh:
                if l_f:
                    l_f=False
                else:
                    kpos.append((kubo*kbh, kubo*kbt))
                    l_f=True
                kbh-=1
        kbt-=1
    l_min=int(kubo*.03)
    l_max=int(kubo*.75)
    l_vmax=int(kubo*1)
    l_vmin=int(kubo*.15)
    #l_c=0
    #l_cv=0
    l_p0=(0,0)
    l_pa=(0,0)
    l_pi=(0,0)
    l_pin=(0,0)
    l_pf=(0,0)
    lin=[]
    pin=[]
    #kpos += (itt.product(range(0,ah-resth,kubo),range(0,at-rest,kubo)))
    # la aranya fa taranyinas
    for kpx in kpos[:]:
        l_cv=0
        l_fv=False
        #l_pin=kpx
        for kt in range(0,kubo):
            l_c=0
            l_f=False
            for kh in range(0,kubo):
                posi=(kpx[0]+kh,kpx[1]+kt)
                if ((bl-abl)*3) <= sum(pix[posi]) <= (bl*3):
                    if abs((sum(posi)-sum(l_pa)))<=1:
                        l_c+=1
                        l_pf=l_pa
                    l_pa=posi
            if l_min <= l_c <= l_max: l_f=True 
            if l_f:
                l_pi=(l_pf[0],kpx[1]+kt)
                if abs((sum(l_pin)-sum(l_pi)))<=4:
                    l_cv +=1
                    l_pin = l_pi
                    #pin.append(l_pin)
                else:
                    l_cv=0
                    l_p0=l_pi
                    l_pin=l_pi
                    pin.append(l_pi)
        if l_vmin <= l_cv: l_fv=True
        if l_fv: lin.append((l_p0,l_pin))
    return lin,pin

def formiga_opt(im,l_cups):
    #ima:780x480=374400px
    #ima:640x480=307200px
    global tram_knt, kubo
    #tram_dif=0
    j_surt=False
    verm=255
    vert=128
    a_verm=int(verm*.08)
    #print abl
    #im = Image.open(fim)
    pix = im.load()
    # la formiga vermella busca areas de color vermell
    px_knt=0
    if tram_knt<1:
        for kpx in l_cups:
            for kt in range(0,kubo):
                for kh in range(0,kubo):
                    posi=(kpx[0]+kh,kpx[1]+kt)
                    pxx=pix[posi]
                    if (verm-a_verm) <= pxx[0] <= verm and sum(pxx) < (verm+3*a_verm):
                        px_knt+=1
        if px_knt >= verm:
            tram_knt+=1
    elif tram_knt<2:
        for kpx in kpos[:]:
            for kt in range(0,kubo):
                for kh in range(0,kubo):
                    posi=(kpx[0]+kh,kpx[1]+kt)
                    pxx=pix[posi]
                    if (verm-a_verm) <= pxx[0] <= verm and sum(pxx) < (verm+3*a_verm):
                        px_knt+=1
        if px_knt >= kubo**2 :
            j_surt=True
    return j_surt

def formiga(im):
    #ima:780x480=374400px
    global tram_knt
    #tram_dif=0
    j_surt=False
    verm=255
    vert=128
    a_verm=int(verm*.08)
    #print abl
    #im = Image.open(fim)
    ah,at=im.size
    pix = im.load()
    res=rest=resth=0
    qav=5
    kubo=at//qav
    for kk in range(qav,int(qav*2),1):
        res=at%kk
        if rest<res :
            kubo= at//kk
            rest=res
            resth=ah%kubo
    cbt=(at//kubo)
    #kbt=cbt
    cbh=(ah//kubo)
    kbh=cbh
    #print ah,at,kubo
    kbt=cbt-1
    kpos=list()
    l_fv=True
    # divisio imatge en sectors, tamany cup
    while kbt:
        l_f=True
        kbh=cbh-1
        if l_fv :
            l_fv=False
            while kbh:
                if l_f:
                    kpos.append((kubo*kbh, kubo*kbt))
                    l_f=False
                else:
                    l_f=True
                kbh-=1
        else: 
            l_fv=True
            while kbh:
                if l_f:
                    l_f=False
                else:
                    kpos.append((kubo*kbh, kubo*kbt))
                    l_f=True
                kbh-=1
        kbt-=1
    # la formiga vermella busca areas de color vermell
    px_knt=0
    if tram_knt<1:
        for kpx in kpos[:]:
            for kt in range(0,kubo):
                for kh in range(0,kubo):
                    posi=(kpx[0]+kh,kpx[1]+kt)
                    pxx=pix[posi]
                    if (verm-a_verm) <= pxx[0] <= verm and sum(pxx) < (verm+3*a_verm):
                        px_knt+=1
        if px_knt >= verm:
            tram_knt+=1
    elif tram_knt<2:
        for kpx in kpos[:]:
            for kt in range(0,kubo):
                for kh in range(0,kubo):
                    posi=(kpx[0]+kh,kpx[1]+kt)
                    pxx=pix[posi]
                    if (verm-a_verm) <= pxx[0] <= verm and sum(pxx) < (verm+3*a_verm):
                        px_knt+=1
        if px_knt >= kubo**2 :
            j_surt=True
    return j_surt

def comput_mov(lin):
    #x_max,y_max=kpos[-1:]
    n,xt,yt=0,0,0
    for klin in lin:
        (x0,y0),(x1,y1)=klin
        #if y1<y_max: break
        xt+=x1-x0
        yt+=y1-y0
        n+=1
        #if xt!=0: m+=yt//xt
    #x_t,y_t= sum([x1-x0 for ((x0,y0),(x1,y1)) in lin ])//len(lin),sum([y1-y0 for ((x0,y0),(x1,y1)) in lin ])//len(lin)
    return (xt/n,yt/n)
    #return x_t,y_t

def comput_dir(v_mov):
    global a_ref
    a_max=25
    x_ni,y_ni=v_mov
    if y_ni != 0 :
        if x_ni < 0 :
            a_dir = a_ref*(2-1/(1-x_ni/y_ni)) #aprox arctan
            a_s='dir_esq'
        elif x_ni > 0 :
            a_dir = a_ref/(1+x_ni/y_ni) 
            a_s='dir_drt'
        else:
            a_dir=a_ref
            a_s='dir_rct'
    else: 
        if x_ni < 0 :
            a_dir = a_ref + a_max
            a_s='dir_esq'
        elif x_ni > 0 :
            a_dir = a_ref - a_max
            a_s='dir_drt'
        else:
            a_dir=a_ref
            a_s='dir_rct'
    if a_dir < (a_ref-a_max): a_dir = a_ref-a_max
    elif a_dir > (a_ref+a_max): a_dir = a_ref + a_max
    #devuelve a_dir:angulo direccion, a_s: interpretacion de la direccion
    return (a_dir,a_s)

def comput_dir_kmp(v_kmp):
    global a_ref
    x_kmp,y_kmp,z_kmp=v_kmp
    if y_kmp != 0 :
        if x_kmp < 0:
            if y_kmp < 0:
                #Q3
                a_dir_kmp = a_ref*(2+1/(1+x_kmp/y_kmp)) #aprox arctan
                a_s_kmp='dir_anr_esq'
            else:
                #Q2
                a_dir_kmp = a_ref*(2-1/(1-x_kmp/y_kmp)) #aprox arctan
                a_s_kmp='dir_esq'
        elif x_kmp > 0 :
            if y_kmp < 0:
                #Q4
                a_dir_kmp = a_ref*(4-1/(1-x_kmp/y_kmp)) #aprox arctan
                a_s_kmp='dir_anr_drt'
            else:
                #Q1
                a_dir_kmp = a_ref/(1-x_kmp/y_kmp) #aprox arctan
                a_s_kmp='dir_drt'
        else:
            a_dir_kmp=a_ref
            a_s_kmp='dir_rt'
    else: 
        if x_kmp < 0 :
            a_dir_kmp = a_ref*2
            a_s_kmp= 'dir_iz'
        elif x_ni >= 0 :
            a_dir_kmp = 0
            a_s_kmp= 'dir_drt'
    return (a_dir_kmp,a_s_kmp)

def comput_poss(v_acc_ni,t_ni):
    global t_n1
    global v_vv_n1
    global v_pos_n1
    t_dif= (t_ni-t_n1)
    #(a_ni,a_s)=v_dir
    (axi,ayi,azi)=v_acc_ni
    (x0,y0,z0)= v_pos_n1
    (xi,yi,zi)= (axi*t_dif**2,ayi*t_dif**2,ayi,azi*t_dif**2)
    (vxi,vyi,vzi)= (axi*t_dif,ayi*t_dif,ayi,azi*t_dif)
    (vx0,vy0,vz0)= v_vv_n1
    (vx1,vy1,vz1)= (vx0+vxi,vy0+vyi,vz0+vzi)   
    (x1,y1,z1)= (x0+vx1*t_dif, y0+vy1*t_dif, z0+vz1*t_dif)
    return (x1,y1,z1),(vx1,vy1,vz1)

def comput_acc(v_tram_ni,v_vv_ni):
    global acc_n1
    k_fren=.339
    k_acc=23
    k_tram=0
    n_tram,(x0,y0),(x1,y1),a_s,tram_ni,tram_mx,(vx_mx,vy_mx)=v_tram_ni
    #(axi,ayi,azi)=v_acc_ni
    (vxi,vyi,vzi)=v_vv_ni
    if tram_ni < tram_mx-int(tram_mx*k_fren):
        if vyi+vxi >= vx_mx+vy_mx:
            acc_ni=acc_n1
            acc_k=1
        else:
            k_tram=tram_mx-int(tram_mx*k_fren)
            acc_k=int(tram_ni/k_tram)
            acc_ni=k_acc*acc_k
    else:
        if vyi+vxi >= vx_mx+vy_mx:
            acc_ni=acc_n1
            acc_k=1
        else:
            k_tram=tram_mx-int(tram_mx*k_fren)-tram_ni
            acc_k=int(tram_ni/k_tram)
            acc_ni=k_acc*acc_k
    return acc_ni,acc_k

def comput_acc_fx(v_vv_ni):
    global acc_n1
    k_acc=3
    acc_k=0
    v_mx=5
    #(vx_mx,vy_mx)=(v_mx,v_mx)
    #(axi,ayi,azi)=v_acc_ni
    (vxi,vyi,vzi)=v_vv_ni
    if vyi >= v_mx:
        acc_ni=acc_n1
        acc_k=1
    else:
        acc_ni+=k_acc
        acc_k=k_acc
    if vxi >= v_mx:
        acc_ni-=k_acc
    return acc_ni,acc_k

def comput_tram(v_dir,v_pos):
    global tram_knt
    global tram_dif
    global tram_fl
    global l_tram
    global v_tram_n1
    global j_stat
    global v_pos_n1
    tram_min=5
    xi,yi,zi=v_pos
    n_tram,(x0,y0),(x1,y1),a_s_n1,tram_n1,tram_kmx,(vx_mx,vy_mx)=v_tram_n1
    if not tram_fl:
        #cambio de tramo y pasamos al siguiente   
        if a_s_n1 == v_dir[1]:
            v_tram=v_tram_n1
            tram_knt+=1
        elif tram_dif<tram_min:
            v_tram=v_tram_n1
            tram_dif+=1
        else:
            if n_tram+tram_min == len(l_tram):
                v_tram=l_tram[tram_min]
            else:
                v_tram=l_tram[n_tram+tram_min+1]
            if j_stat=='ubicant':
                v_pos_n1=(x1,y1,0)
                j_stat='ubicat'
    else:
        if a_s_n1 == v_dir[1]:
            v_tram=v_tram_n1
            tram_knt+=1
            if tram_dif>1:
                tram_dif-=1
            elif tram_dif<tram_min:
                v_tram=v_tram_n1
                tram_dif+=1
                if tram_dif==1:
                    v_tram[3]=v_dir[1]
        else:
        #genera l_tram a medida que recorre el circuito
        #tampoco mapea la pista
            v_tram[5]=tram_kmx=tram_knt
            v_tram[4]=tram_knt=0
            #v_tram[3]=a_s_n1
            v_tram[2]=(xi,yi)
            v_tram[0]=tram_min+n_tram
            l_tram.insert(v_tram[0],(v_tram))
            v_tram[4]=v_tram[5]=0
            v_tram[3]=v_dir[1]
            v_tram[1]=v_tram[2]
            v_tram[0]=tram_min+n_tram+1
            l_tram.insert(v_tram[0],(v_tram))
            if j_stat=='ubicant':
                v_pos_n1=(xi,yi,0)
                j_stat='ubicat'
        if len(l_tram) > tram_min**2:
            for nt in range(len(l_tram)-tram_min):
                n_tram,(x0,y0),(x1,y1),a_s_n,tram_n,tram_kmx,(vx_mx,vy_mx)=l_tram[nt+tram_min]
                if x0<x1 and y0<y1:
                    if x0<xi<x1 and y0<yi<y1:
                        v_tram=l_tram[nt+tram_min]
                        tram_fl=False
                        break
                elif x1<x0 and y1<y0:
                    if x1<xi<x0 and y1<yi<y0:
                        v_tram=l_tram[nt+tram_min]
                        tram_fl=False
                        break
        v_tram[4]=tram_knt
    return v_tram

def comput_tram_map(v_dir,v_pos):
    global j_stat
    global tram_knt
    global tram_dif
    global l_tram
    global l_carr
    tram_min=5
    a_dir_ni,a_s_ni=v_dir
    xti,yti,zti=0,0,0
    xi,yi,zi=v_pos
    v_tram=l_tram[4]
    #n_tram,(x0,y0),(x1,y1),a_s_n1,tram_n1,tram_kmx,(vx_mx,vy_mx)=v_tram_n1
    if tram_dif<1:
        if  a_s_ni == v_tram[3]:
            tram_knt+=1
        elif tram_knt<1:
            v_tram[1]=(xi,yi)
            v_tram[3]=a_s_ni
            tram_knt+=1
        else:
            tram_dif+=1
    elif tram_dif<2:
        n_tram,(x0,y0),(x1,y1),a_s_n1,tram_n1,tram_kmx,(vx_mx,vy_mx)=l_tram[1]
        if a_s_ni == a_s_n1:
            tram_dif-=1
        else:
            tram_dif+=1
        tram_knt+=1
    elif tram_dif<3:
        n_tram,(x0,y0),(x1,y1),a_s_n2,tram_n1,tram_kmx,(vx_mx,vy_mx)=l_tram[2]
        if a_s_ni == a_s_n2:
            tram_dif-=1
        else:
            tram_dif+=1
        tram_knt+=1
    else:
        #n_tram,(x0,y0),(x1,y1),a_s_n3,tram_n1,tram_kmx,(vx_mx,vy_mx)=l_tram[3]
        n_tram=len(l_tram)
        v_tram[0]=n_tram-tram_min
        v_tram[2]=(xi,yi)
        v_tram[5]=tram_knt
        v_tram[4]=tram_knt=tram_dif=0
        l_carr.append((kmp.lee_kmp()))
        l_tram.append((v_tram))
        if n_tram > tram_min**2:
            for nt in range(n_tram-tram_min):
                n_tram,(x0,y0),(x1,y1),a_s_n,tram_n,tram_kmx,(vx_mx,vy_mx)=l_tram[nt+tram_min]
                if x0<xi<x1 and y1<yi<y0:
                    j_stat='mapafet'
                    v_tram=l_tram[nt+tram_min]
                    #promedio kmp del circuito (x,y,z)
                    kt=len(l_carr)
                    for kmp in range(1,kt):
                        xti,yti,zti=l_carr[kmp]
                        xt+=xti
                        yt+=yti
                        zt+=zti
                    d_circ,v_kmp_circ,v_kmp_sort,v_kmp_kas,n_tram_sal,v_pos_sal,n_tram_kas,v_pos_kas=l_tram[0]
                    l_tram[0]=d_circ,(xt/kt,yt/kt,zt/kt),v_kmp_sort,v_kmp_kas,n_tram_sal,v_pos_sal,n_tram_kas,v_pos_kas
                    for kmp in range(1,kt):
                        del l_carr[kmp]
                    break
    l_tram[4]=v_tram
    l_tram[3]=l_tram[2]
    l_tram[2]=l_tram[1]
    l_tram[1]=l_tram[4]
    return v_tram

def navg_ini():
    global pv_w
    l_out=[13,17,18]
    l_in=[15]
    pv_f=300
    gp.setmode(gp.BCM)
    gp.setup(l_out, gp.OUT)
    gp.setup(l_in, gp.IN)
    pv_w=gp.PWM(l_out[0],pv_f)
    pv_w.start(0)

def navg_fi():
    global pv_w
    #l_out=[13,17,18]
    #l_in=[15]
    pv_w.stop()
    
def navg_timon(a_ni,a_s):
    global a_ref
    global v_dir_n1
    global j_stat
    a_n1,a_s_n1=v_dir_n1
    a_dif=3
    a_dif_ni=0
    pv_d=18
    pv_e=17
    gp.output(pv_e, gp.LOW)
    gp.output(pv_d, gp.LOW)
    if a_s == 'dir_esq':
        if a_ni < a_n1 :
            a_dif_ni=a_n1-a_ni
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_d, gp.HIGH)
        else:
            a_dif_ni=a_ni-a_n1
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_e, gp.HIGH)
    elif a_s == 'dir_drt':
        if a_ni < a_n1 :
            a_dif_ni=a_n1-a_ni
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_d, gp.HIGH)
        else:
            a_dif_ni=a_ni-a_n1
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_e, gp.HIGH)
    elif a_s == 'dir_rct': 
        if a_ni < a_ref :
            a_dif_ni=a_n1-a_ni
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_d, gp.HIGH)
        else:
            a_dif_ni=a_ni-a_n1
            if a_dif_ni > a_dif:
                for k_ti in range (int(a_dif_ni/a_dif)):
                    gp.output(pv_e, gp.HIGH)
    else:
        j_stat='err-2'
    gp.output(pv_e, gp.LOW)
    gp.output(pv_d, gp.LOW)

def navg_acc(acc_ni,acc_k):
    global pv_w
    global acc_n1
    a_mx=430
    d_mn=13
    d_mx=75
    if acc_ni != acc_n1:
        if acc_ni > 0:
            for k_cca in range(1,acc_k):
                pv_w.ChangeDutyCycle(d_mn+int(d_mx*(acc_ni/a_mx)*(k_cca/acc_k)))
        elif acc_ni < 0:
            for k_cca in range(1,acc_k):
                pv_w.ChangeDutyCycle(int(d_mn*(1+(acc_ni/a_mx)*(k_cca/acc_k))))

        
def plot_pin(pin,im):
    #fnm,ext = pth.splitext(fim)
    #im = Image.open(fim)
    #print 'ima::',im.filename
    imc = Image.new('RGB',im.size,(0,53,103))
    draw = ImageDraw.Draw(imc)
    for kpin in pin :
        draw.point(kpin,'red')
    imcg = Image.blend(im,imc,0.95)
    #imcg.save(im.filename.rsplit('.',1)[0]+'_lin.png','PNG')                
    return imcg

def plot_lin(lin,im):
    #fnm,ext = pth.splitext(fim)
    #im = Image.open(fim)
    #print 'ima::',im.filename
    imc = Image.new('RGB',im.size,(0,53,103))
    draw = ImageDraw.Draw(imc)
    for klin in lin:
        draw.line(klin,'white',1)
    #imc.save(im.filename.rsplit('.',1)[0]+'_lin.png','PNG')
    return imc

def plot_lin_vm(lin,imt):
    #fnm,ext = pth.splitext(fim)
    #imt = Image.open(im.filename.rsplit('.',1)[0]+'_lin.png')
    imc = imt.copy()
    draw = ImageDraw.Draw(imc)
    draw.line(lin,'red',3)
    #imc.save(im.filename.rsplit('.',1)[0]+'_lin.png','PNG')
    return imc

def plot_gri(kpos,kubo,im,iml):
    #fnm,ext = pth.splitext(fim)
    #im = Image.open(fim)
    #print 'ima::',im.filename
    #iml= Image.open(im.filename.rsplit('.',1)[0]+'_lin.png')
    imc= im.copy()
    draw = ImageDraw.Draw(imc)
    for kpx in kpos[:]:
        draw.rectangle([kpx,(kpx[0]+kubo,kpx[1]+kubo)],'black',outline='white')
    imcg = Image.blend(im,imc,0.35)
    img = Image.blend(imcg,iml,0.85)
    img.save(im.filename.rsplit('.',1)[0]+'_gri.png','PNG')                
    
