#!/usr/bin/python
# -*- coding: latin-1 -*-
"""
proyecto: juk-100
descripcion: rc 1/18 autonomo, una camara, cuatro ruedas ,+rpi
soft: raspbian + python + C + bash
autor: jgf
fechas: inicio 14-2-16 v100, final indf.
licencia: gpl
PROGRAMA
 juk.py: maquina d'estats per l'automata juk, ARCWagen
DESCRIPCION
 estados posibles realacionados en el dicionario d_stats
 donde el estado inicial (e_ni) se relaciona con el modo siguiente (m_n1)
 definicion de estados:
 - rodat: recorre el circuito y espera instruccion nueva
 - inici: inicio progrma donde carga los parametros del circuito 
 - iniciat: termina el modo de inicio dentro de pista 
 - mapeig: medida del circuito, identificacion de tramos y areas
 - mapafet: fin del mapeo
 - ubicat: estimacion de la ubicacion actual dentro del circuito
 - llestos: espera vandera roja antes del inicio inmediato de la carrera
 - verd: rueda el circuito en bucle infinito
 - rodat: terminada la carrera vuelve al area casa
 - err-xx: estados de error posibles, donde espera ordenes
 - mossegat: en modo de juego gremlin termina el estado al interceptar al rival. 
 definicion de modos de juego:
 - kasa: vuelve al area de inicio y termina el programa de estados
 - arcade: rodaje en circuito - en bucle infinito
 - mapache: modo normal de mapeo
 - gremlin: modo de molestar
 - bandera: modo carrera 
 - pista: modo de ubicacion en pista antes de la carrera
 - escolti: modo de espera, donde se def. el modo siguinte
MEJORAS TODO
difnicion del tramo cero de la lista l_tram en una funcion inicial sino generada 
 fijar el punto medio del circuito en v_kmp_circ
 fijar el punto de sortida en v_kmp_sort
 fijar vector de casa en v_kmp_cas
 fijar la posicion del punto de salida en v_pos_sal
 y fijar area de casa en v_pos_kas
mejorar trazada dentro de cada tramo: trazada optima
definir todos los paramtros dentro de una libreria llamada juk_metrica.py
completar funciones para el modo gremlin: ce.juk_mossega(),Lvas.rivalis()
"""
#LIBRERIAS
from io import BytesIO
import time
#from picamera import PiCamera
#from PIL import Image
import sys
import os
import soc as so
import mut as mo
import cek as ce
import Lvas
import pickle
#GLOBALES
f_car=True
j_mode='escolti'
j_stat='iniciat'
l_tram=list()
l_carr=list()
d_stats={'rodat':'escolti',
         'inici':'pista',
         'iniciat':'escolti',
         'mapeig':'mapache',
         'imap':'mapache',
         'mapafet':'escolti',
         'rodat':'kasa',
         'ubicat':'escolti',
         'llestos':'bandera',
         'verd':'arcade',
         'rodat':'escolti',
         'err-0':'escolti',
         'err-1':'escolti',
         'err-2':'escolti',
         'err-3':'escolti',
         'err-u':'escolti',
         'err-os':'escolti',
         'err-io':'escolti',
         'err-fi':'escolti',
         'mossegat':'escolti'}

def juk_mk_stts():
    global j_mode
    global d_stats
    global j_stat
    try:
        if j_mode == 'bandera':
            while j_stat == 'llestos':
                j_stat=ce.juk_sortida()
            while j_stat == 'zebra':
                j_stat=ce.juk_zareb()
        elif j_mode == 'arcade':
            while j_stat == 'verd':
                j_stat=ce.juk_el_cek()
        elif j_mode == 'mapache':
            if j_stat == 'imap':
                j_stat=ce.juk_circuit_ini()
            while j_stat == 'mapeig':
                 j_stat=ce.juk_mapeig()
            if j_stat == 'mapafet':
                j_stat=ce.juk_mapafet()
        elif j_mode == 'pista':
            if j_stat == 'inici':
                j_stat=ce.juk_circuit()
            while j_stat == 'ubicant':
                j_stat=ce.juk_ubicacio()
            if j_stat == 'ubicat':
                j_stat=ce.juk_ubicat()
        elif j_mode == 'gremlin':
            j_stat=ce.juk_mossega()
        elif j_mode == 'escolti':
            j_stat=ce.juk_diguim()
        elif j_mode == 'kasa':
            j_stat=ce.juk_kapakasa()
            if j_stat == 'fi':
                f_car=False
    except IOError as err:
        t = time.localtime()
        with  open('juk.log','a') as f_log:
            f_log.writeline(t.tm_min,':',t.tm_sec,' err:',err)
    finally:
        ##diccionario de estados: establece el modo  
        if d_stats.has_key(j_stat):
            j_mode=d_stats[j_stat]
        return f_car

if __name__ == "__main__":
    try:
        ce.juk_in()
        while juk_mk_stts()
    finally:
        ce.juk_fi()
